@ ECE271 Lab4 -- GPIO/LED in Assembly

.include "stm32l476xx_asm.h"

.cpu cortex-m4
.syntax unified
.thumb

.equ	STACK_LOCATION,	(0x20000000+(96*1024))

.word	STACK_LOCATION	/* top of stack address */
.word	Reset_Handler	/* reset vector*/
.word	loop_forever	/* nmi vector */
.word	loop_forever	/* hard fault vector */
			/* There are more vectors, assume won't happen? */

.globl Reset_Handler
.thumb_func
Reset_Handler:

	bl	System_Clock_Init



	/************************************/
	/* Put your code here ***************/
	/************************************/



loop_forever:
	b	loop_forever


	/************************************/
	/* Don't touch the code below *******/
	/************************************/


	@=======================
	@ System Clock Init
	@=======================
System_Clock_Init:

	/* Set some register offsets to use */
	ldr	r1,=RCC_BASE

        /* Reset the RCC clock to the default reset state */
        /* Set MSION bit */
	ldr	r3,[r1,#RCC_CR]		@ load RCC->CR
	orr	r3,r3,#RCC_CR_MSION	@ RCC->CR |= RCC_CR_MSION;
	str	r3,[r1,#RCC_CR]

        /* Reset CFGR register */
	mov	r3,#0
	str	r3,[r1,#RCC_CFGR]	@ RCC->CFGR = 0x00000000U;

        /* Reset HSEON, CSSON , HSION, and PLLON bits */
	ldr	r3,[r1,#RCC_CR]		@ load RCC->CR
	ldr	r4,=0xEAF6FFFF
	and	r3,r4
	str	r3,[r1,#RCC_CR]		@ RCC->CR &= 0xEAF6FFFFU;

        /* Reset PLLCFGR register */
	mov	r3,#0x00001000
	str	r3,[r1,#RCC_PLLCFGR]	@ RCC->PLLCFGR = 0x00001000U;

        /* Reset HSEBYP bit */
	ldr	r3,[r1,#RCC_CR]		@ load RCC->CR
	bic	r3,#RCC_CR_HSEBYP
	str	r3,[r1,#RCC_CR]		@ RCC->CR &= ~(RCC_CR_HSEBYP);

        /* Disable all interrupts */
	mov	r3,#0
	str	r3,[r1,#RCC_CIER]	@ RCC->CIER = 0x00000000U;

	blx	lr


